package jUnitTest;

import login.login;
import java.io.File;
import java.io.IOException;
import java.net.URL;

import javax.faces.component.UIComponent;
import javax.inject.Inject;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.container.test.api.OverProtocol;
import org.jboss.arquillian.test.api.ArquillianResource;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.jsfunit.api.InitialPage;
import org.jboss.jsfunit.jsfsession.JSFClientSession;
import org.jboss.jsfunit.jsfsession.JSFServerSession;
import org.jboss.jsfunit.jsfsession.JSFSession;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.EmptyAsset;
import org.jboss.shrinkwrap.api.spec.WebArchive;
//import org.jboss.shrinkwrap.resolver.api.maven.Maven;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;


import org.jboss.jsfunit.*;




@RunWith(Arquillian.class)
public class loginPageTest {
	
	@Deployment
	@OverProtocol("Servlet 3.0")
	  public static WebArchive createDeployment() {
		//File[] libs = Maven.resolver().loadPomFromFile("pom.xml").importRuntimeAndTestDependencies().asFile();
		
		
	      WebArchive war =
	         ShrinkWrap.create(WebArchive.class, "platform.war")
	            .setWebXML(new File("src/main/webapp/junit/web.xml"))
	            .addPackage("jUnitTest")
	            //.addPackages(true, "login", "objects", "dal", "init", "jUnitTest")
	            .addAsWebResource(new File("src/main/webapp/", "index.xhtml"))          
	            .addAsWebInfResource(new File("src/main/webapp/junit/faces-config.xml"), "faces-config.xml")
	            .addAsWebInfResource(EmptyAsset.INSTANCE, "beans.xml");
	      
	    /*  for(File file : libs){
	            war.addAsLibrary(file);
	        }*/
	      
	      System.out.println(war.toString(true)); // for debugging
	      return war;
	   }
	
	
	@Inject login loginObj;
	@Test
	public void testLoginBeanInjection(){
		loginObj = new login();
		Assert.assertNotNull(loginObj);
	}
	
	@Test
	@InitialPage("/index.xhtml")
	 public void testInitialPage(JSFServerSession server, JSFClientSession client) throws IOException {
		//client..getWebClient().setRedirectEnabled(true);
		//loginObj = new login();
		
		
		
	     // Test navigation to initial viewID
	     Assert.assertEquals("/index.xhtml", server.getCurrentViewID());
	     //System.out.println("Client Value" + client.getPageAsText() );
	     // Set the param and submit
	     client.setValue("username", "user");
	     client.setValue("password", "pw");
	     System.out.println("BEFORE CLICK!");
	     client.click("loginButton");
	     
	     //System.out.println(client.getContentPage().getWebResponse().getContentAsString());
	     System.out.println("auth: " + server.getManagedBeanValue("#{auth}"));
	     System.out.println("CLICK!");
	     // Assert that the greeting component is in the component tree and rendered
	     UIComponent greeting = server.findComponent("username");
	     Assert.assertTrue(greeting.isRendered());
	 
	     // Test a managed bean using EL. We cheat and use the request object.
	     //Assert.assertEquals("Stan", server.getManagedBeanValue("#{request.getParameter('form1:name')}"));
	 }

}
